import pytest
import mock

from blockerbugs.util import pagure_interface


class TestPagureInterface(object):
    @mock.patch('blockerbugs.util.pagure_interface.requests.post')
    def test_create_issue_rises_non_200(selfm, mock_post):
        mock_post.return_value.status_code = 404

        with pytest.raises(pagure_interface.PagureAPIException):
            pagure_interface.create_issue("foo", "bar")

    @mock.patch('blockerbugs.util.pagure_interface.requests.post')
    @mock.patch('blockerbugs.util.pagure_interface.Bug')
    def test_update_issue_rises_non_200(selfm, Bug, mock_post):
        mock_post.return_value.status_code = 404

        with pytest.raises(pagure_interface.PagureAPIException):
            pagure_interface.update_issue("foo", "bar")

    @mock.patch('blockerbugs.util.pagure_interface.requests.get')
    def test_get_issue_rises_non_200(selfm, mock_get):
        mock_get.return_value.status_code = 404

        with pytest.raises(pagure_interface.PagureAPIException):
            pagure_interface.get_issue(123)

    @mock.patch('blockerbugs.util.pagure_interface.requests.post')
    def test_post_comment_rises_non_200(selfm, mock_post):
        mock_post.return_value.status_code = 404

        with pytest.raises(pagure_interface.PagureAPIException):
            pagure_interface.post_comment(123, "foo")
